/*********************************************************************
** Copyright (C) 2003 Terabit Pty Ltd.  All rights reserved.
**
** This file is part of the POSIX-Proactor module.
**
** This file may be distributed and used only under the terms of the  
** Terabit Public License as defined by Terabit Pty Ltd of Australia   
** and appearing in the file tlicense.txt included in the packaging of
** this module and available at http://www.terabit.com.au/license.php.
**
** Contact support@terabit.com.au if any conditions of this licensing
** are not clear to you.
**********************************************************************/

/* -*- C++ -*- */

//=============================================================================
/**
 *
 *
 *  @file    POSIX_AIO_Linux_RT_Strategy.h
 *
 *  $Id:  $
 *
 *  @author Alexander Libman <libman@terabit.com.au>
 */
//=============================================================================

#ifndef ACE_POSIX_AIO_LINUX_RT_STRATEGY_H
#define ACE_POSIX_AIO_LINUX_RT_STRATEGY_H

#include "ace/POSIX_AIO_Select_Provider.h"

#if (defined(ACE_HAS_AIO_CALLS) || defined(ACE_HAS_AIO_EMULATION)) && defined(linux)


//Forward declarations

/**
 * @class ACE_POSIX_AIO_Linux_RT_Strategy
 *
 */
class ACE_POSIX_AIO_Linux_RT_Strategy:
  public ACE_POSIX_AIO_Select_Strategy_Base
{
protected:

  friend class ACE_POSIX_AIO_Select_Provider;
  
  ACE_POSIX_AIO_Linux_RT_Strategy (ACE_POSIX_AIO_Select_Provider & provider);
  virtual ~ACE_POSIX_AIO_Linux_RT_Strategy();


  // Wait Strategy Interface

  // use base class
  // virtual ACE_POSIX_AIO_Interrupt_Strategy * create_interrupt_strategy (void);
  
  // use base class
  // virtual void 
  //  destroy_interrupt_strategy (ACE_POSIX_AIO_Interrupt_Strategy * i_strategy);

  virtual int init (void);
  virtual int fini (void);
  
  virtual int  on_aio_start (ACE_POSIX_Asynch_Result * result);
  
  virtual int  prepare_to_wait (ACE_POSIX_Asynch_Waiting_List & started_list);

  virtual int  wait (ACE_Time_Value * wait_time);

  virtual ACE_POSIX_Asynch_Result * 
    get_next_completed_result (ACE_POSIX_Asynch_Waiting_List & started_list);

  virtual int declare_interest (ACE_HANDLE handle, u_int mask);
  virtual int clear_interest   (ACE_HANDLE handle, u_int mask);

private:


  static void sig_handler (int sig_num, siginfo_t *, ucontext_t *);

  int setup_signal_handler (int sig_num, int flg_ign) const;

  int mask_signals (int how, const sigset_t *signals) const;

  int wait_i (timespec * wait_time);

  ACE_POSIX_Asynch_Result * test_result (ACE_HANDLE handle);


  int sig_num_;
  int flg_sigio_;
  sigset_t signal_mask_;

  int pid_;
  ACE_thread_t tid_;

};



#endif /* ACE_HAS_AIO_CALLS  && linux */
#endif /* ACE_POSIX_AIO_LINUX_RT_STRATEGY_H */
