/*********************************************************************
** Copyright (C) 2003 Terabit Pty Ltd.  All rights reserved.
**
** This file is part of the POSIX-Proactor module.
**
** This file may be distributed and used only under the terms of the  
** Terabit Public License as defined by Terabit Pty Ltd of Australia   
** and appearing in the file tlicense.txt included in the packaging of
** this module and available at http://www.terabit.com.au/license.php.
**
** Contact support@terabit.com.au if any conditions of this licensing
** are not clear to you.
**********************************************************************/

/* -*- C++ -*- */

//=============================================================================
/**
 *  @file    ACE_POSIX_AIO_Poll_Strategy.h
 *
 *  $Id:  $
 *
 *  @author Alexander Libman <libman@terabit.com.au>
 */
//=============================================================================

#ifndef ACE_POSIX_AIO_POLL_STRATEGY_H
#define ACE_POSIX_AIO_POLL_STRATEGY_H

#include "ace/POSIX_AIO_Select_Provider.h"


#if defined (ACE_HAS_AIO_CALLS) || defined(ACE_HAS_AIO_EMULATION)

/**
 * @class ACE_POSIX_AIO_Dev_Poll_Strategy
 *
 */

class ACE_Export ACE_POSIX_AIO_Poll_Strategy :
  public ACE_POSIX_AIO_Select_Strategy_Base
{
protected:

  friend class ACE_POSIX_AIO_Select_Provider;
  
  ACE_POSIX_AIO_Poll_Strategy (ACE_POSIX_AIO_Select_Provider & provider);
  virtual ~ACE_POSIX_AIO_Poll_Strategy();


  // Wait Strategy Interface

  // use base class
  // virtual ACE_POSIX_AIO_Interrupt_Strategy * create_interrupt_strategy (void);
  
  // use base class
  // virtual void 
  //  destroy_interrupt_strategy (ACE_POSIX_AIO_Interrupt_Strategy * i_strategy);
  virtual int init (void);
  virtual int fini (void);

  virtual int  on_aio_start (ACE_POSIX_Asynch_Result * result);
  
  virtual int  prepare_to_wait (ACE_POSIX_Asynch_Waiting_List & started_list);

  virtual int  wait (ACE_Time_Value * wait_time);

  virtual ACE_POSIX_Asynch_Result * 
    get_next_completed_result (ACE_POSIX_Asynch_Waiting_List & started_list);


  virtual int declare_interest (ACE_HANDLE handle, u_int mask);
  virtual int clear_interest   (ACE_HANDLE handle, u_int mask);

private:

  struct pollfd * poll_fds_;

  /// Pointer to the next pollfd array element that contains the next
  /// event to be dispatched.
  struct pollfd * next_fds_;
  u_int num_events_;

};


#endif /* ACE_HAS_AIO_CALLS */
#endif /* ACE_POSIX_AIO_POLL_STRATEGY_H */
