/*********************************************************************
** Copyright (C) 2003 Terabit Pty Ltd.  All rights reserved.
**
** This file is part of the POSIX-Proactor module.
**
** This file may be distributed and used only under the terms of the  
** Terabit Public License as defined by Terabit Pty Ltd of Australia   
** and appearing in the file tlicense.txt included in the packaging of
** this module and available at http://www.terabit.com.au/license.php.
**
** Contact support@terabit.com.au if any conditions of this licensing
** are not clear to you.
**********************************************************************/

// ============================================================================
/**
 *  @file ARWSession.cpp
 *
 *
 *  @author Alexander Libman <libman@terabit.com.au>
 */
// ============================================================================

#include "ARWSession.h"

#if defined (ACE_HAS_THREADS) && \
    ((defined (ACE_WIN32) && !defined (ACE_HAS_WINCE)) || (defined (ACE_HAS_AIO_CALLS)))
// This only works on Win32 platforms and on Unix platforms
// supporting POSIX aio calls.


#if defined (ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION)

template class ACE_Asynch_RW<ACE_Asynch_Read_Stream,ACE_Asynch_Write_Stream>;
template class ACE_Asynch_RW_Stream<ACE_Asynch_Read_Stream,ACE_Asynch_Write_Stream>;

#elif defined (ACE_HAS_TEMPLATE_INSTANTIATION_PRAGMA)

#pragma instantiate ACE_Asynch_RW<ACE_Asynch_Read_Stream,ACE_Asynch_Write_Stream>
#pragma instantiate ACE_Asynch_RW_Stream<ACE_Asynch_Read_Stream,ACE_Asynch_Write_Stream>

#endif /* ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION */


// ***************************************************
//
// ***************************************************
ARWSession::ARWSession ()
  : PSession ()
{
}

ARWSession::~ARWSession (void)
{
}

void
ARWSession::cancel ()
{
  this->stream_.cancel_and_close();
}

int 
ARWSession::is_safe_to_delete (void) 
{
  return !this->has_pending_io();
}

void
ARWSession::on_open (ACE_HANDLE handle)
{
  if (this->stream_.open (*this, 
                          handle,
                          0, // completion key,
                          this->task().proactor(),
                          1) == -1)
    {
      ACE_ERROR ((LM_ERROR,
                  ACE_TEXT ("(%t) %s %p\n"),
                  this->get_name(),
                  ACE_TEXT ("ACE_Asynch_RW_Stream::open")));

       return;
    }
}


int
ARWSession::start_asynch_read (ACE_Message_Block &mb, size_t bytes)
{
    return this->stream_.read (mb, bytes);
}
int
ARWSession::start_asynch_write (ACE_Message_Block &mb, size_t bytes)
{
    return this->stream_.write (mb, bytes);
}

#endif  /* ACE_WIN32 && !ACE_HAS_WINCE || ACE_HAS_AIO_CALLS */
