/*********************************************************************
** Copyright (C) 2003 Terabit Pty Ltd.  All rights reserved.
**
** This file is part of the POSIX-Proactor module.
**
** This file may be distributed and used only under the terms of the  
** Terabit Public License as defined by Terabit Pty Ltd of Australia   
** and appearing in the file tlicense.txt included in the packaging of
** this module and available at http://www.terabit.com.au/license.php.
**
** Contact support@terabit.com.au if any conditions of this licensing
** are not clear to you.
**********************************************************************/

// ============================================================================
//
// = AUTHOR
//    Alexander Libman <libman@terabit.com.au>
//
// ============================================================================

#ifndef ACE_PROACTOR_TASK_H
#define ACE_PROACTOR_TASK_H

#include "TaskPool.h"

#if defined (ACE_HAS_THREADS) 

#if (defined (ACE_WIN32) && !defined (ACE_HAS_WINCE)) || defined(ACE_HAS_AIO_CALLS)

#include "ace/Proactor.h"


class ProactorTask : public TaskPool
{
public:
  ProactorTask (TestCfg & cfg);
  virtual ~ProactorTask();

 
  ACE_Proactor * proactor(void) { return this->proactor_;}

protected:
  virtual int create_demultiplexor(void);
  virtual int delete_demultiplexor(void);
  virtual int run_event_loop(void);
  virtual int end_event_loop(void);


  ACE_Proactor * proactor_;
};

#endif  //(ACE_WIN32) && !defined (ACE_HAS_WINCE)) || defined(ACE_HAS_AIO_CALLS)

#endif  // (ACE_HAS_THREADS) 

#endif  /*ACE_PROACTOR_TASK_H*/

