// ============================================================================
//
// = LIBRARY
//    tests
//
// = FILENAME
//    ProactorTask.h
//
// = DESCRIPTION
//    Define class needed for generating templates. IBM C++ requires this to
//    be in its own file for auto template instantiation.
//
// = AUTHOR
//    Alexander Libman <alibman@optusnet.com.au>
//
// ============================================================================

#ifndef ACE_PROACTOR_TASK_H
#define ACE_PROACTOR_TASK_H

#include "TaskPool.h"

#if defined (ACE_HAS_THREADS) 

#if (defined (ACE_WIN32) && !defined (ACE_HAS_WINCE)) || defined(ACE_HAS_AIO_CALLS)

#include "ace/Proactor.h"


class ProactorTask : public TaskPool
{
public:
  ProactorTask (TestCfg & cfg);
  virtual ~ProactorTask();

 
  ACE_Proactor * proactor(void) { return this->proactor_;}

protected:
  virtual int create_demultiplexor(void);
  virtual int delete_demultiplexor(void);
  virtual int run_event_loop(void);
  virtual int end_event_loop(void);


  ACE_Proactor * proactor_;
};

#endif  //(ACE_WIN32) && !defined (ACE_HAS_WINCE)) || defined(ACE_HAS_AIO_CALLS)

#endif  // (ACE_HAS_THREADS) 

#endif  /*ACE_TESTS_TASKPOOL_H*/

