#! /bin/sh

S=1
T=1
K=512
I=1
W=512
D=0
X=0
M=0

if [ -n "$1" ]; then S=$1; fi 
if [ -n "$2" ]; then T=$2; fi 
if [ -n "$3" ]; then K=$3; fi 
if [ -n "$4" ]; then I=$4; fi 
if [ -n "$5" ]; then W=$5; fi 
if [ -n "$6" ]; then D=$6; fi 
if [ -n "$7" ]; then X=$7; fi 
if [ -n "$8" ]; then M=$8; fi 


echo "=== Sessions=$S Threads=$T Blk=$K Win=$W Delay=$D Time=$I Xfer=$X TOut=$M"
#
echo -e "\n-----TP_Reactor"
/usr/bin/time T_Test   -b  -w$W -d$D -v2 -i$I -s$S -n$T -k$K
mv  log_unix/T_Test.log ./tp_reactor.log

echo -e "\n-----Proactor=Select leader=SHARED"
/usr/bin/time P_Test -tE -b  -w$W -d$D -v2 -i$I -s$S -n$T -k$K -lS -x$X -m$M
mv  log_unix/P_Test.log ./select_shared.log

echo -e "\n-----Proactor=Poll leader=SHARED"
/usr/bin/time P_Test -tP -b  -w$W -d$D -v2 -i$I -s$S -n$T -k$K -lS -x$X -m$M
mv  log_unix/P_Test.log ./poll_shared.log

echo -e "\n-----Proactor=Select leader=DEDICATED"
/usr/bin/time P_Test -tE -b  -w$W -d$D -v2 -i$I -s$S -n$T -k$K -lD -x$X -m$M 
mv  log_unix/P_Test.log ./select_dedicated.log

echo  -e "\n-----Proactor=Linux_RT leader=DEDICATED start_in=ANY"
/usr/bin/time P_Test -tR -b  -w$W -d$D -v2 -i$I -s$S -n$T -k$K -lD -aA -x$X -m$M
mv  log_unix/P_Test.log ./linux_rt.log

echo  -e "\n-----Proactor=LINUX_NAIO leader=SHARED start_in=ANY"
/usr/bin/time P_Test -tL -b  -w$W -d$D -v2 -i$I -s$S -n$T -k$K -lS -x$X -m$M
mv  log_unix/P_Test.log ./linux_naio.log

echo  -e "\n-----Proactor=Linux_EPOLL leader=SHARED start_in=ANY"
/usr/bin/time P_Test -tO -b  -w$W -d$D -v2 -i$I -s$S -n$T -k$K -lS -x$X -m$M
mv  log_unix/P_Test.log ./linux_epoll.log

#echo -en "Proactor: Linux_RT , leader=DEDICATED, start_in=LEADER\t"
#/usr/bin/time P_Test -tR -b  -w$W -d$D -v2 -i$I -s$S -n$T -k$K -lD -aL -x$X -m$M
#tail log_unix/P_Test.log | grep "bytes/sec" | sed -e 's/^[^=]* = //'
#mv  log_unix/P_Test.log ./linuxRT_leader.log

echo -e "\n--- Sessions=$S Threads=$T Blk=$K Win=$W Delay=$D Time=$I sec"

echo -en "TP_Reactor \t\t\t\t\t\t"
tail -n 20 tp_reactor.log  | grep "bytes/sec"  | sed -e 's/^[^=]* = //'

echo -en "Proactor=Select leader=SHARED\t\t\t\t"
tail -n 20 select_shared.log  | grep "bytes/sec"  | sed -e 's/^[^=]* = //'

echo -en "Proactor=Poll   leader=SHARED\t\t\t\t"
tail -n 20 poll_shared.log  | grep "bytes/sec"  | sed -e 's/^[^=]* = //'

echo -en "Proactor=Select leader=DEDICATED\t\t\t"
tail -n 20 select_dedicated.log  | grep "bytes/sec"  | sed -e 's/^[^=]* = //'

echo -en "Proactor=Linux_RT leader=DEDICATED, start_in=ANY\t"
tail -n 20 linux_rt.log  | grep "bytes/sec"  | sed -e 's/^[^=]* = //'

echo -en "Proactor=LINUX_NAIO leader=SHARED, start_in=ANY\t"
tail -n 20 linux_naio.log  | grep "bytes/sec"  | sed -e 's/^[^=]* = //'

echo -en "Proactor=Linux_EPOLL leader=SHARED, start_in=ANY\t"
tail -n 20 linux_epoll.log  | grep "bytes/sec"  | sed -e 's/^[^=]* = //'
